/* <<< Start of information >>>                                       */
/* ------------------------------------------------------------------ */
/* This file is part of the xwatch program. Copyright (C) ICCE /      */
/* Karel Kubat 1995. All rights reserved. You are permitted to        */
/* redistribute this package, if you include all unmodified sources   */
/* and all unmodified documentation (including this text). You are    */
/* NOT permitted to distribute files of this package with             */
/* modifications.  See the file COPYING for more information. When in */
/* doubt, mail me at karel@icce.rug.nl.                               */
/* XWatch is maintained by Frank Brokken, frank@icce.rug.nl. If you   */
/* have remarks about bugs or features, please mail Frank.            */
/* ------------------------------------------------------------------ */
/* <<< End of information >>>                                         */

#include "xwatch.h"

int getcolorindex (int red, int green, int blue)
{
    register int
	i;
    int
	r, g, b;
    static int
	lastdefined = FL_FREE_COL1 - 1;
    
    /* see if color table already has the r/g/b */
    for (i = 0; i <= lastdefined; i++)
    {
	fl_getmcolor (i, &r, &g, &b);
	if (red == r && g == green && b == blue)
	    return (i);
    }

    /* now reassign it */
    lastdefined++;
    if (lastdefined > FL_FREE_COL16)
    {
	warning ("Failure to create color %d/%d/%d", red, green, blue);
	return (FL_BLACK);
    }
    fl_mapcolor (lastdefined, red, green, blue);
    
    return (lastdefined);
}
